var current_conference = -1;
var current_conference_offset = 0;
var current_thread = -1;
var unread_in_current_thread = null;
var keep_current_conference_in_unread_list = false;

var previous_conference = -1;
var previous_thread = -1;

function kom_view_conference(id, first_thread, skip_thread_list)
{
	document.getElementById(kom_instantmessageview_name).style.display = "none";
	var viewelm = document.getElementById(kom_threadview_name);
	viewelm.style.display = "block";
	highlight_menu_item("kom_meeting_"+id);
	if (current_conference != id)
		keep_current_conference_in_unread_list = false;
		
	previous_conference = current_conference;
	previous_thread = current_thread;

	current_conference = id;
	current_conference_offset = first_thread;
	current_thread = -1;

	for (var i = 0; i < subconfs.length; ++i)
	{
		if (subconfs[i][0] == id)
		{
			if (!parseInt(subconfs[i][2]))
			{
				keep_current_conference_in_unread_list = true;
			}
			if (parseInt(subconfs[i][3]))
			{
				viewelm.innerHTML = "You have been invited to join this conference. <a href='#' onclick='kom_change_subscription_type("+id+", 0, 0, 0);return false;'>Accept</a> <a href='#' onclick='kom_unsubscribe("+id+");return false;'>Decline</a>";
				return;
			}
		}
	}

	viewelm.innerHTML = "Loading...";
	kom_begin_progress();

	// List the threads
	var threadlist;
	if (skip_thread_list)
		threadlist = ["OK"];
	else if (id == 0)
		threadlist = kom_command("list_favorites").split(KOM_GROUP_SEPARATOR);
	else
		threadlist = kom_command("list_threads " + id + " " + first_thread + " " + kom_threads_per_page).split(KOM_GROUP_SEPARATOR);
	var conf_name = kom_lookup_name(id);
	if (id == 0)
		conf_name = "Favorites"
	if (threadlist[0] != "OK")
	{
		viewelm.innerHTML = "<h2>"+conf_name+"</h2>";
		kom_end_progress();
		return;
	}
	// Prefetch all names to avoid reflowing much while layouting the page
	var prefetch_id = new Array();
	for (var i = 1; i < threadlist.length-1; ++i)
	{
		var thread = threadlist[i].split(KOM_RECORD_SEPARATOR);
		prefetch_id.push(thread[1]);
	}
	kom_prefetch_names(prefetch_id);
	viewelm.innerHTML = "";
	if (id != 0)
	{
		var compose_elm = document.createElement("div");
		compose_elm.setAttribute("class", "kom_compose_to_conference");
		compose_elm.innerHTML = "<a href='#New_thread' onclick='kom_view_compose(0, \""+id+"\");return false;'>New Thread</a>";
		viewelm.appendChild(compose_elm);

		var elm = document.createElement("div");
		elm.setAttribute("class", "kom_mark_all_read");
		elm.innerHTML = "<a href='#Mark_all_read' onclick='kom_mark_conference_read("+id+");return false;'>Mark all read</a>";
		viewelm.appendChild(elm);
	}
	viewelm.innerHTML += "<h2>"+conf_name+"</h2>";
	for (var i = 1; i < threadlist.length-1; ++i)
	{
		var thread = threadlist[i].split(KOM_RECORD_SEPARATOR);
		if (thread.length == 5)
		{
			var elm = document.createElement("div");
			elm.setAttribute("onClick", "kom_view_thread("+thread[0]+", " + id + ");return false;");
			elm.setAttribute("class", "kom_thread_item");
			var name = kom_lookup_name(thread[1]);
			elm.innerHTML = "<div style='float:left;'>" + thread[3] + "</div>";
			if (thread[4] != 1)
			{
				elm.setAttribute("class", "kom_thread_item_new");
			}
			var ctime = new Date(parseInt(thread[2]*1000));
			elm.innerHTML += "<div style='float: right;'>" + name + " <span class='kom_message_date'>" + ctime.toLocaleString() + "</span></div>&nbsp;";
			viewelm.appendChild(elm);
		}
	}
	// last entry tells us if there is more threads
	if (first_thread > 0)
	{
		var elm = document.createElement("div");
		elm.setAttribute("class", "kom_view_newer_threads");
		elm.innerHTML = "<a href='#View_newer' onclick='kom_view_conference("+id+","+(first_thread-kom_threads_per_page)+");return false;'>View newer</a>";
		viewelm.appendChild(elm);
	}
	if (parseInt(threadlist[threadlist.length-1]) != 0)
	{
		var elm = document.createElement("div");
		elm.setAttribute("class", "kom_view_older_threads");
		elm.innerHTML = "<a href='#View_older' onclick='kom_view_conference("+id+","+(first_thread+kom_threads_per_page)+");return false;'>View older</a>";
		viewelm.appendChild(elm);
	}
	kom_end_progress();
}

function kom_ignore_thread()
{
	kom_command("ignore_thread " + current_thread);
	kom_view_thread(current_thread, current_conference, true);
}

function kom_view_thread(id, conf, reloading)
{
	var viewelm = document.getElementById(kom_threadview_name);
	if (!reloading)
	{
		viewelm.innerHTML = "Loading...";
	}

	current_thread = id;

	// List the threads
	var threadlist = kom_command("list_messages " + id + " " + conf).split(KOM_GROUP_SEPARATOR);
	var active_elm = document.activeElement;
	var confname = kom_lookup_name(conf);
	if (parseInt(conf) == 0)
		confname = "Favorites";
	if (threadlist[0] != "OK")
	{
		if (!reloading)
		{
			if (parseInt(conf) < 0)
				viewelm.innerHTML = "<h2>No conference</h2>";
			else
				viewelm.innerHTML = "<h2><a href='#' onclick='kom_view_conference("+conf + ", " + current_conference_offset + ");return false;'>" + confname + "</a></h2>";
		}
		return;
	}
	// Prefetch all names to avoid reflowing much while layouting the page
	var prefetch_id = new Array();
	for (var i = 2; i < threadlist.length; ++i)
	{
		var thread = threadlist[i].split(KOM_RECORD_SEPARATOR);
		prefetch_id.push(thread[1]);
	}
	kom_prefetch_names(prefetch_id);

	var firstunreadelm = null;
	var lastunreadelm = null;
	var indentStack = new Array();
	var onlyChild = new Array();
	var indentDepth = 0;
	indentStack[0] = 1;
	onlyChild[0] = true;
	if (!reloading)
		unread_in_current_thread = new Array();
	var root_text_elm = document.createElement("div");
	root_text_elm.setAttribute("class", "kom_message_root_container");
	var current_parent_elm = root_text_elm;
	var ignored_thread = parseInt(threadlist[1]);
	for (var i = 2; i < threadlist.length; ++i)
	{
		var msgcontainerelm = document.createElement("div");
		var tmsg = threadlist[i].split(KOM_RECORD_SEPARATOR);
		msgcontainerelm.setAttribute('message_id', tmsg[0]);
		var titleelm;
		var msgelm = document.getElementById("msg_text_"+tmsg[0]);
		if (msgelm)
		{
			titleelm = document.getElementById("kom_message_title_"+tmsg[0]);
			titleelm.className = titleelm.className.replace(/kom_message_title_fake_indent/g, "kom_message_title");
			msgcontainerelm.appendChild(titleelm);
			msgcontainerelm.appendChild(msgelm);
		}
		else
		{
			titleelm = document.createElement("div");
			msgelm = document.createElement("div");
			titleelm.setAttribute("onclick", "toggle_message_visible("+tmsg[0]+");return false;");
			titleelm.setAttribute("id", "kom_message_title_"+tmsg[0]);
			titleelm.setAttribute("class", "kom_message_title");
			if (current_parent_elm.hasAttribute('message_id'))
			{
				var current_parent = current_parent_elm.getAttribute('message_id');
				msgelm.setAttribute("onmouseover", "var pelm = document.getElementById('kom_message_title_"+current_parent+"');if (pelm) pelm.setAttribute('hover_child','"+tmsg[0]+"');return true;");
				msgelm.setAttribute("onmouseout", "var pelm = document.getElementById('kom_message_title_"+current_parent+"');if (pelm && pelm.getAttribute('hover_child')=='"+tmsg[0]+"') pelm.removeAttribute('hover_child');return true;");
			}
			msgelm.setAttribute("id", "msg_text_"+tmsg[0]);
			msgelm.setAttribute("class", "kom_message_text");
			var messageContentType = tmsg[8];
			var messageTitle = tmsg[9].substring(0, tmsg[9].indexOf("\n"));
			var messageText = tmsg[9].replace(/.*\n/, "");
			var name = kom_lookup_name(tmsg[1]);
			titleelm.innerHTML = "<div style='float:left;'><img class='username' src='img/icon_user.png' onclick='ShowPresentationPopup(event, this)'>" + name + "</div>";
			titleelm.userid = tmsg[1];
			if (!(parseInt(tmsg[5])&1) && !reloading)
			{
				msgelm.style.display = "block";
			}
			var ctime = new Date(parseInt(tmsg[4])*1000);
			titleelm.innerHTML += "<div style='float: right;'>" + messageTitle + " <span class='kom_message_date'>(" + tmsg[0] + ") " + ctime.toLocaleString() + "</span></div>&nbsp;";
			msgelm.innerHTML = "";
			if (tmsg[2] != "")
			{
				var toelm = document.createElement("div");
				toelm.setAttribute("class", "kom_message_to_list");
				toelm.innerHTML = "To: "
				var toList = tmsg[2].split(',');
				toelm.innerHTML += kom_lookup_name(toList[0]); 
				for (var toi = 1; toi < toList.length; ++toi)
					toelm.innerHTML += ", " + kom_lookup_name(toList[toi]); 
				var imgsrc = "img/star_gray.png";
				if (parseInt(tmsg[6]))
					imgsrc = "img/star_gold.png";
				toelm.innerHTML += "<img src='"+imgsrc+"' style='float:right;' id='favorite_img_"+tmsg[0]+"' onClick='kom_toggle_favorite("+tmsg[0]+")'>";
				msgelm.appendChild(toelm);
			}
			if (tmsg[3] != "")
			{
				var ccelm = document.createElement("div");
				ccelm.setAttribute("class", "kom_message_to_list");
				ccelm.innerHTML = "Cc: "
				var toList = tmsg[3].split(',');
				ccelm.innerHTML += kom_lookup_name(toList[0]); 
				for (var toi = 1; toi < toList.length; ++toi)
					ccelm.innerHTML += ", " + kom_lookup_name(toList[toi]); 
				msgelm.appendChild(ccelm);
			}
			if (messageContentType.substring(0,5) == "text/")
			{
				if (messageText.indexOf("  ") >= 0)
				{
					msgelm.className = "kom_message_text_monospace";
				}
				msgelm.innerHTML += "<br><div class='kom_message_content'>" + kom_postprocess_message(messageText).replace(/\n/g, "<br>") + "</div>";
			}
			else if (messageContentType.substring(0,6) == "image/")
			{
				msgelm.innerHTML += "<br><div class='kom_message_content'><img src='data:"+messageContentType+";base64,"+messageText+"'></div>";
			}
			else
			{
				msgelm.innerHTML += "<br><div class='kom_message_content'>*Unknown content, "+messageContentType+"*</div>";
			}
			var reelm = document.createElement("div");
			// toggle_reply_visible will ask the backend for a new reply list based on the to list
			reelm.setAttribute("onclick", "toggle_reply_visible("+tmsg[0] + "," +tmsg[1] + ",'" + tmsg[2] + "',\"" + escape(kom_html_to_plain(messageTitle)) + "\");return false;");
			reelm.setAttribute("class", "kom_message_replytoggle");
			reelm.innerHTML = "Reply";
			msgelm.appendChild(reelm);
			msgelm.innerHTML += "<div class='kom_message_reply' id='msg_reply_"+tmsg[0]+"'></div>";

			// If not read, mark as read
			if (!(parseInt(tmsg[5])&1))
			{
				if (reloading)
				{
					unread_in_current_thread[parseInt(tmsg[0])] = true;
					titleelm.className += " unread_text";
				}
				else
				{
					kom_command("mark_read "+conf+" "+tmsg[0], true);
					if (!firstunreadelm)
						firstunreadelm = msgcontainerelm;
					lastunreadelm = msgcontainerelm;
				}
			}
			msgcontainerelm.appendChild(titleelm);
			msgcontainerelm.appendChild(msgelm);
		}
		var current_fake_indent = false;
		if (indentDepth > 0 && onlyChild[indentDepth] && onlyChild[indentDepth-1])
		{
			titleelm.className = titleelm.className.replace(/kom_message_title/g, "kom_message_title_fake_indent");
			msgcontainerelm.setAttribute("class", "kom_message_container_fake_indent");
			current_fake_indent = true;
		}
		else
			msgcontainerelm.setAttribute("class", "kom_message_container");
		if (current_fake_indent)
			current_parent_elm.parentNode.appendChild(msgcontainerelm);
		else
			current_parent_elm.appendChild(msgcontainerelm);
		current_parent_elm = msgcontainerelm;
		indentStack[indentDepth+1] = parseInt(tmsg[7]);
		--indentStack[indentDepth];
		++indentDepth;
		onlyChild[indentDepth] = (parseInt(tmsg[7]) == 1);
		while (indentStack[indentDepth] <= 0 && indentDepth > 0)
		{
			if (indentDepth > 1 && onlyChild[indentDepth-1] && onlyChild[indentDepth-2])
				current_parent_elm = current_parent_elm.previousSibling;
			else
				current_parent_elm = current_parent_elm.parentNode;
			--indentDepth;
		}
	}
	if (parseInt(conf) < 0)
		viewelm.innerHTML = "<h2>No conference</h2>";
	else
		viewelm.innerHTML = "<h2><a href='#' onclick='kom_view_conference("+conf + ", " + current_conference_offset + ");return false;'>" + confname + "</a></h2>";
	if (ignored_thread)
		viewelm.innerHTML += "<h3>Thread is ignored!</h3>\n";
	if (root_text_elm)
		viewelm.appendChild(root_text_elm);
	if (reloading && active_elm)
		active_elm.focus();

	var elm = document.createElement("div");
	elm.innerHTML = "<div style='float:right;'><a href='#' onclick='kom_expand_all(0); return false;'>Collapse all</a> - <a href='#' onclick='kom_expand_all(1); return false;'>Expand all</a></div>";
	viewelm.appendChild(elm);

	if (!ignored_thread)
	{
		elm = document.createElement("div");
		elm.innerHTML = "<a href='#' onclick='kom_ignore_thread(); return false;'>Ignore thread until next login</a>";
		viewelm.appendChild(elm);
	}
	if (firstunreadelm && !reloading)
	{
		var bottom = root_text_elm.offsetHeight;
		var curoffsetelm;
		for (curoffsetelm = root_text_elm; curoffsetelm; curoffsetelm = curoffsetelm.offsetParent)
			bottom += curoffsetelm.offsetTop;
		var ypos = 0;
		if (bottom > window.innerHeight)
		{
			ypos = -50;
			for (curoffsetelm = firstunreadelm; curoffsetelm; curoffsetelm = curoffsetelm.offsetParent)
				ypos += curoffsetelm.offsetTop;
			// FIXME: if the last unread is not in view, indicate that there are more unread messages further down

		}
		window.scrollTo(0, ypos);
	}
}

function kom_previous_thread()
{
	kom_view_thread(previous_thread, previous_conference, true);
}

function kom_toggle_favorite(id)
{
	// Get the state from the image
	var imgelm = document.getElementById("favorite_img_"+id);
	if (imgelm.src.match("star_gray.png$"))
	{
		// Make it a favorite
		if (kom_command("set_favorite " + id + " 1").split(KOM_GROUP_SEPARATOR)[0] == "OK")
		{
			imgelm.src = "img/star_gold.png";
		}
	}
	else
	{
		// Remove the favorite status
		if (kom_command("set_favorite " + id + " 0").split(KOM_GROUP_SEPARATOR)[0] == "OK")
		{
			imgelm.src = "img/star_gray.png";
		}
	}
}

function toggle_message_visible(id)
{
	var elm = document.getElementById("msg_text_"+id);
	if (elm.style.display != "block")
	{
		if (unread_in_current_thread[id])
		{
			kom_command("mark_read "+current_conference+" "+id, true);
			unread_in_current_thread[id] = false;
			var titleelm = document.getElementById("kom_message_title_"+id);
			titleelm.className = titleelm.className.replace(/ unread_text/g, "");
		}
		elm.style.display = "block";
	}
	else
		elm.style.display = "none";
}

function kom_expand_all(expand)
{
	var viewelm = document.getElementById(kom_threadview_name);
	var tagCollection = viewelm.getElementsByTagName("div");
	for (var i = 0; i < tagCollection.length; ++i)
	{
		if (tagCollection[i].className == "kom_message_text" ||
			tagCollection[i].className == "kom_message_text_monospace")
		{
			if ((expand && tagCollection[i].style.display != "block") ||
				(!expand && tagCollection[i].style.display == "block"))
				toggle_message_visible(tagCollection[i].id.substring(9));
		}
	}
}

function kom_mark_conference_read(conf)
{
	kom_command("mark_read "+conf, true);
}

function kom_view_next_unread_thread()
{
	var nextThread = kom_command("next_unread_thread").split(KOM_GROUP_SEPARATOR);
	if (nextThread[0] != "OK")
		return;
	if (nextThread.length > 1)
	{
		var cm = nextThread[1].split(KOM_RECORD_SEPARATOR);
		if (cm.length != 2)
			return;
		kom_view_conference(cm[0], 0, true);
		kom_view_thread(cm[1], cm[0]);
	}
}

function kom_view_compose(replyTo, toList, title)
{
	if (!replyTo)
	{
		document.getElementById(kom_instantmessageview_name).style.display = "none";
		document.getElementById(kom_threadview_name).style.display = "block";
	}
	var viewelm = document.getElementById(replyTo?('msg_reply_'+replyTo):kom_threadview_name);
	// Remove all children
	viewelm.innerHTML = replyTo?"":"<h2>Compose</h2>";

	var replyToParam = replyTo?replyTo:"";
	var copyQuote = "";
	if (replyTo)
	{
		copyQuote = " <a href='#' onclick='kom_compose_copy_text("+replyTo+", true);return false;'>Quote message</a> <a href='#' onclick='kom_compose_copy_text("+replyTo+", false);return false;'>Copy message</a>";
	}
	viewelm.innerHTML += "<form class='kom_compose_form' onkeyup='kom_cancel_key(event);' onsubmit='kom_compose_send_message("+replyToParam+");return false;'>\n" +
			"<div><a href='#' onclick='kom_compose_add_to("+replyToParam+");return false;' id='lnk_add_to"+replyToParam+"'><span class='kom_compose_label'>To:</span></a> </div>\n" +
			"<div><a href='#' onclick='kom_compose_add_cc("+replyToParam+");return false;' id='lnk_add_cc"+replyToParam+"'><span class='kom_compose_label'>Cc:</span></a> </div>\n" +
			"<div><span class='kom_compose_label'>Subject: </span><input size='72' type='text' id='kompose_subject"+replyToParam+"' onkeyup='kom_cancel_key(event);'></div>\n" +
			"<div><span class='kom_compose_label'> </span><textarea cols='72' rows='20' id='kompose_text"+replyToParam+"' onkeyup='kom_cancel_key(event);'></textarea>\n" +
			"<div><span class='kom_compose_label'>&nbsp;</span><input type='submit' value='Send'>"+copyQuote+"</div></div>\n" +
			"</form>\n";	

	if (replyTo)
	{
		document.getElementById("kompose_subject"+replyToParam).value = title;
		var tos = toList.split(",");
		for (var i = 0; i < tos.length; ++i)
			kom_compose_add_to(replyTo, parseInt(tos[i]));

		// Reply addresses and subject are already set, let's set focus to the
		// message input box.
		viewelm.getElementsByTagName('textarea')[0].focus();
	}
	else
	{
		if (toList)
		{
			var tos = toList.split(",");
			for (var i = 0; i < tos.length; ++i)
				kom_compose_add_to(replyTo, parseInt(tos[i]));

			// We already have a bunch of recipients, but no subject, let's set
			// the input focus to the subject input.
			document.getElementById("kompose_subject"+replyToParam).focus();
		}
		else
		{
			kom_compose_add_to(replyTo);
			// No to-addresses yet, let's set input focus to the forst
			// to-field.
			viewelm.getElementsByTagName('input')[0].focus();
		}
	}

	if (!replyTo)
	{
		highlight_menu_item("menu_new_mess");
	}
}

function kom_compose_add_to(replyTo, confNum)
{
	var replyToParam = replyTo?replyTo:"";
	var lnk = document.getElementById("lnk_add_to"+replyToParam);
	kom_compose_add_to_or_cc(lnk, confNum);
}

function kom_compose_add_cc(replyTo, confNum)
{
	var replyToParam = replyTo?replyTo:"";
	var lnk = document.getElementById("lnk_add_cc"+replyToParam);
	kom_compose_add_to_or_cc(lnk, confNum);
}

function kom_compose_add_to_or_cc(lnk, confNum)
{
	lnk.setAttribute("class", "kom_compose_label kom_to_cc_label");
	var elm = createConferenceSelector(true, true);
	lnk.parentNode.appendChild(elm);
	if (confNum)
	{
		selectConference(elm.getAttribute("id"), confNum);
	}
}

function kom_compose_copy_text(replyTo, quote)
{
	var msgelm = document.getElementById("msg_text_"+replyTo);
	var tagCollection = msgelm.getElementsByTagName("div");
	for (var i = 0; i < tagCollection.length; ++i)
	{
		if (tagCollection[i].getAttribute("class") == "kom_message_content")
		{
			var msgtext = tagCollection[i].innerHTML.replace(/<br>/ig, "\r\n");
			msgtext = msgtext.replace(/<a[^>]*>/ig, "");
			msgtext = msgtext.replace(/<\/a>/ig, "");
			msgtext = msgtext.replace(/<img[^>]*>/ig, "*Image*");
			msgtext = kom_html_to_plain(msgtext);
			var curtext = document.getElementById("kompose_text"+replyTo);
			var prevtext = curtext.value;
			if (quote)
			{
				curtext.wrap = "hard";
				curtext.value = ">" + msgtext;
				var curIndex = curtext.value.indexOf("\r\n");
				var prevIndex = 0;
				while (curIndex != -1)
				{
					msgtext = msgtext.substring(curIndex-prevIndex-1);
					if (msgtext.indexOf("\r\n") == 0)
						msgtext = msgtext.substring(2);
					curtext.value = curtext.value.substring(0, curIndex+2) + ">" + msgtext;
					prevIndex = curIndex+2;
					curIndex = curtext.value.indexOf("\r\n", prevIndex);
				}
				msgtext = curtext.value;
				curtext.wrap = "";
			}
			curtext.value = msgtext;
			if (curtext.value == prevtext)
				return;
			if (prevtext != "" && !confirm("This operation will replace the current text"))
				curtext.value = prevtext;
			return;
		}
	}
}

function kom_compose_send_message(replyTo)
{
	var replyToParam = replyTo?replyTo:"";
	var todiv = document.getElementById("lnk_add_to"+replyToParam).parentNode;
	var ccdiv = document.getElementById("lnk_add_cc"+replyToParam).parentNode;

	var toArray = new Array();
	var ccArray = new Array();
	var tagCollection = todiv.getElementsByTagName("div");
	for (var i = 0; i < tagCollection.length; ++i)
	{
		if (tagCollection[i].getAttribute("name") == "conference_selector")
		{
			var komid = getSelectedConference(tagCollection[i].getAttribute("id"));
			if (komid > 0)
				toArray.push(komid);
			else if (komid < 0)
			{
				alert("Could not send message, invalid recipient");
				return;
			}
		}
	}
	var tagCollection = ccdiv.getElementsByTagName("div");
	for (var i = 0; i < tagCollection.length; ++i)
	{
		if (tagCollection[i].getAttribute("name") == "conference_selector")
		{
			var komid = getSelectedConference(tagCollection[i].getAttribute("id"));
			if (komid > 0)
				ccArray.push(komid);
			else if (komid < 0)
			{
				alert("Could not send message, invalid recipient");
				return;
			}
		}
	}
	if (!toArray.length)
	{
		alert("No recipient specified");
		return;
	}

	var subj = document.getElementById("kompose_subject"+replyToParam).value;
	var text = document.getElementById("kompose_text"+replyToParam).value.replace(/\r/g, "");
	subj = subj.replace("/^\s+/", "");
	while (subj.charAt(0) == ' ')
		subj = subj.substring(1);
	text = text.replace("\r\n", "\n");
	var cmd = "send_message";
	if (replyTo)
		cmd += " reply " + replyTo;
	cmd += " to ";
	for (var i = 0; i < toArray.length; ++i)
		cmd += toArray[i] + " ";
	if (ccArray.length)
		cmd += "cc ";
	for (var i = 0; i < ccArray.length; ++i)
		cmd += ccArray[i] + " ";
	cmd += "text " + KOM_RECORD_SEPARATOR + subj + "\n" + text + KOM_RECORD_SEPARATOR;
	var rep = kom_command(cmd).split(KOM_GROUP_SEPARATOR);
	if (rep[0] == "OK")
	{
		if (replyTo)
		{
			document.getElementById("msg_reply_"+replyTo).innerHTML = "";
			toggle_reply_visible(replyTo);
			if (parseInt(rep[1]) > 0)
			{
				kom_view_thread(parseInt(rep[1]), current_conference, true);
				// fake a click on the new text to expand it and mark it as read
				toggle_message_visible(parseInt(rep[1]));
			}
		}
		else
		{
			if (parseInt(rep[1]) > 0)
			{
				kom_view_conference(parseInt(rep[2]), 0, true);
				kom_view_thread(parseInt(rep[1]), parseInt(rep[2]));
			}
			else
				kom_view_compose();
		}
	}
	else
		alert("Could not send message: " + rep[1]);
}

function toggle_reply_visible(id, from, toList, title)
{
	var elm = document.getElementById('msg_reply_' + id);
	if (elm.style.display != "block")
	{
		elm.innerHTML = "Loading..."
		elm.style.display = "block";
		var newTo = kom_command("get_reply_recpt from " + from + " to " + toList.replace(/,/g, " ")).split(KOM_GROUP_SEPARATOR);
		if (newTo[0] == "OK")
		{
			toList = newTo[1].split(KOM_RECORD_SEPARATOR).join(",");
		}
		kom_view_compose(id, toList, unescape(title));
		elm.getElementsByTagName("textarea")[0].focus();
	}
	else
	{
		elm.innerHTML = "";
		elm.style.display = "none";
	}
}


